unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, StdCtrls, dav7components;

type
  TForm1 = class(TForm)
    newBtn: TSpeedButton;
    playBtn: TSpeedButton;
    Label1: TLabel;
    helpBtn: TSpeedButton;
    msglabel: TLabel;
    clearBtn: TSpeedButton;
    hintImage: TImage;
    Label3: TLabel;
    Image1: TImage;
    Label4: TLabel;
    xcheckbox: TCheckBox;
    orgBtn: TSpeedButton;
    queenImage: TImage;
    warningbox: TCheckBox;
    Label6: TLabel;
    Label5: TLabel;
    infoBtn: TSpeedButton;
    loadBtn: TSpeedButton;
    saveBtn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    sizebox: TPaintBox;
    colorbox1: TPaintBox;
    gamebox: TPaintBox;
    procedure clearBtnClick(Sender: TObject);
    procedure hintImageClick(Sender: TObject);
    procedure colorboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure colorboxPaint(Sender: TObject);
    procedure colorboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure helpBtnClick(Sender: TObject);
    procedure warningboxClick(Sender: TObject);
    procedure orgBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure newBtnClick(Sender: TObject);
    procedure infoBtnClick(Sender: TObject);
    procedure loadBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure sizeboxPaint(Sender: TObject);
    procedure sizeboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure colorbox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure colorbox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure colorbox1Paint(Sender: TObject);
    procedure gameboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure gameboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure gameboxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure gameboxPaint(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure xcheckboxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TgameState =(gsNew,gsPlay);
  TMsg = (msNormal,msWarning,msError);

const version = $10;
      formheader = 'Queens puzzle:';

var
  Form1: TForm1;
  gameState : TgameState = gsNew;
  
procedure paintedges(ct : Tcontrol; w : byte; col : longword);
procedure GameMessage(msgText: string);
procedure map2box;
procedure Cell2Box(n : byte);
procedure paintCell(n : byte);
procedure paintAllCells;
procedure HMarkcell(n,Htype : byte);
procedure UpdateCell(n : byte);
procedure ResizeGame(newGS : byte);

implementation

{$R *.dfm}

uses game_unit,io_unit,ELbox_unit;

const colorTable : array[0..15] of longword =
                  ($ffffff,
                   $8080ff,$8080c0,$4040c0,
                   $80ff80,$80c080,$40c040,
                   $ffff00,$ffa0a0,$ff8080,
                   $c0c0c0,$808080,$e0a0e0,
                   $00ffff,$00c0ff,$ff60ff);

      welcome = 'Welcome at the queens puzzle. Enter or select game.';
      gameOKmessage = 'Game OK, start playing';

var selcolorNr : byte;     //colorbox selection
    tempcolorNr : byte;
    oldcell : byte;        //of game
    map : Tbitmap;
    Gtest : TtestResult;

procedure UpdateCell(n : byte);
begin
 paintCell(n);
 cell2Box(n);
end;

procedure GameMessage(msgText : string);
begin
 form1.msglabel.Caption := msgText;
end;

procedure createMap;
begin
 map:= Tbitmap.Create;
 with map do
  begin
   width := gamesize*48;
   height := width;
   pixelformat := pf32bit;
  end;
end;

procedure map2box;
begin
 form1.gamebox.Canvas.Draw(0,0,map);
end;  

procedure paintedges(ct : Tcontrol; w : byte; col : longword);
//line around control
var i : byte;
    par : TComponent;
    x1,y1,x2,y2 : word;
begin
 par := ct.getParentcomponent;
 with Tcustomform(par) do with canvas do
  begin
   x1 := ct.left-w;
   y1 := ct.top-w;
   x2 := ct.left+ct.width+w-1;
   y2 := ct.top+ct.height+w-1;
   pen.width := 1;
   pen.color := col;
   for i:= 0 to w-1 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

procedure paintColRowNrs;
var x,y : word;
    i,w : word;
    s : string;
begin
 with form1 do with Canvas do
  begin
   font.Color := $000000;
   font.Name := 'arial';
   font.Height := 14;
   brush.Style := bsClear;
   x := gamebox.left;
   y := gamebox.top;
   for i := 1 to gamesize do
    begin
     s := inttostr(i);
     w := textwidth(s);
     textout(x-w-5,y+i*48-30,s);
     textout(x+i*48-28,y-15,s);
    end;
  end;
end;

procedure clearMap;
var i : word;
begin
 with map do with canvas do
  begin
   brush.color := $ffffff;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
   i := 0;
   pen.color := $000000;
   pen.Width := 1;
   while i < width do
    begin
     moveto(0,i);
     lineto(width,i);
     moveto(i,0);
     lineto(i,height);
     inc(i,48);
    end;
  end;
end;

procedure ResizeGame(newGS : byte);
var w,x,y :word;
    c,r,n : byte;
begin
 if newGS = gamesize then exit;
//
 gamesize := newGS and $f;
 gamesize2 := gamesize*gamesize;
 newGame;
 w := gamesize*48+1;
 x := 30 + (577-w) shr 1;
 y := 80 + (577-w) shr 1;
 with form1 do with canvas do
  begin
   brush.Color := color;
   brush.Style := bsSolid;
   fillrect(rect(5,55,625,660));
   gamebox.Left:= x;
   gamebox.Top := y;
   gamebox.Width := w;
   gamebox.Height := w;
   paintedges(gamebox,2,$000000);
  end;
//
 with map do with canvas do
  begin
   width := w;
   height := w;
  end;
//
 clearMap;
 n := 0;
 c := 1;
 r := 1;
 repeat
  inc(n);
  with game[n] do begin
                   Gcol := c;
                   Grow := r;
                  end;
  inc(c);
  if c > gamesize then begin
                         c := 1;
                         inc(r);
                        end;
 until r > gamesize;
 paintColRowNrs;
end;

procedure clearBox(bx : Tpaintbox);
begin
 with bx do with canvas do
  begin
   brush.color := $ffffff;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
end;

function getcolorboxrect(n : byte) : Trect;
//n is cell 1,2,3...
var col, row : byte;
begin
 if n > 0 then
  begin
   col := (n-1) mod 3;
   row := (n-1) div 3;
   result.Left := col*25;
   result.top := row*25;
   result.Right := result.Left+25;
   result.Bottom := result.Top+25;
  end;
end;

procedure paintColorBox1;
var i : word;
    r : Trect;
begin
 with form1.colorbox1 do with Canvas do
  begin
   pen.width :=1;
   pen.Color := $000000;
   brush.style := bsSolid;
   for i := 1 to 15 do
    begin
     r := getcolorboxrect(i);
     brush.Color := colorTable[i];
     fillrect(r);
    end;
  end;
end;

function XY2ColorNr(x,y : word) : byte;
var col,row : byte;
begin
 col := x div 25;
 row := y div 25;
 if (col < 3) and (row < 5) then result := 3*row + col + 1
  else result := 0;
end;

procedure paintcolorMarker(nr : byte; col : longword);
var r : Trect;
    i : byte;
begin
 r := getColorboxRect(nr);
 with form1.colorbox1.canvas do
  begin
   pen.color := col;
   pen.width := 1;
   for i := 0 to 1 do
    begin
     moveto(r.left+i,r.top+i);
     lineto(r.left+i,r.bottom-i-1);
     lineto(r.right-i-1,r.bottom-i-1);
     lineto(r.right-i-1,r.top+i);
     lineto(r.left+i,r.top+i);
    end;
  end;
end;

procedure clearColorMarker(nr :byte);
var col : longword;
begin
 if nr > 0 then
  begin
   col := colorTable[nr];
   paintcolormarker(nr,col);
  end; 
end;

procedure setColorMarker(nr : byte);
begin
 clearcolorMarker(selcolorNr);
 selcolorNr := tempcolorNr;
 paintColorMarker(selcolorNr,$000000);
 tempcolorNr := 0;
end;

function Cell2Rect(nr : byte) : Trect;
//nr : game cell nr
var x,y : word;
begin
 dec(nr);
 x := (nr mod gamesize)*48;
 y := (nr div gamesize)*48;
 result.Left := x + 1;
 result.Right := x + 47;
 result.Top := y + 1;
 result.Bottom := y + 47;
end;

function XY2CellNr(x,y : word) : byte;
var col,row : byte;
begin
 col := x div 48;
 row := y div 48;
 result := 1+col+row*gamesize;
end;

procedure paintfences;
//fat line between regions
var r : Trect;
    col,row,k,n : byte;

  procedure line1;
  begin
   with map do with Canvas do
    begin
     moveto(r.Right,r.Top);
     lineto(r.Right,r.bottom);
    end;
  end;

  procedure line2;
  begin
   with map do with Canvas do
    begin
     moveto(r.Left,r.Top);
     lineto(r.Right,r.Top);
    end;
  end;

  procedure line3;
  begin
   with map do with Canvas do
    begin
     moveto(r.Left,r.Top);
     lineto(r.Left,r.Bottom)
     end;
    end;

  procedure line4;
  begin
   with map do with Canvas do
    begin
     moveto(r.Left,r.Bottom);
     lineto(r.Right,r.Bottom);
    end;
  end;

begin
 with map.Canvas do
  begin
   pen.Width := 1;
   for n := 1 to gamesize2 do 
    begin
     col := ((n-1) mod gamesize)+1;
     row := ((n-1) div gamesize)+1;
     pen.Color := $ffffff;
     r := Cell2Rect(n);
     if col < gamesize then line1;
     if row > 1 then line2;
     if col > 1 then line3;
     if row < gamesize then line4;
     pen.Color := $000000;
     for k := 1 to 4 do
      case k of
       1 : if (col < gamesize) then
            if  (game[n].colorNr <> game[n+1].colorNr) then line1;
       2 : if (row > 1) then
            if  (game[n].colorNr <> game[n-gamesize].colorNr) then line2;
       3 : if (col > 1) then
            if  (game[n].colorNr <> game[n-1].colorNr) then line3;
       4 : if (row < gamesize) then
            if  (game[n].colorNr <> game[n+gamesize].colorNr) then line4;
      end;//case, for k
    end;//for n
  end;//with map
 map2box;
end;

procedure Cell2Box(n : byte);
var r : Trect;
begin
 r :=Cell2Rect(n);
 form1.gamebox.Canvas.CopyRect(r,map.Canvas,r);
end;

procedure paintCell(n : byte);
var r : Trect;
begin
 r := Cell2Rect(n);
 with map.Canvas do
  begin
   font.name := 'arial';
   font.height := 14;
   font.style := [];
   font.color:= 0;
   brush.Color := colorTable[game[n].colorNr];
   brush.Style := bsSolid;
   fillrect(rect(r.Left+1,r.Top+1,r.Right,r.Bottom));
   with game[n] do
    begin
     if status = clClosed then
      begin
       pen.Width := 2;
       moveto(r.Left+16,r.Top+16);
       lineto(r.Left+32,r.Top+32);
       moveto(r.Left+32,r.Top+16);
       lineto(r.Left+16,r.Top+32);
       if Qlev > 0 then
        begin
         pen.width := 1;
         moveto(r.left+24,r.top+18);
         lineto(r.left+24,r.top+30);
         moveto(r.left+18,r.top+24);
         lineto(r.left+30,r.top+24)
        End;
      end;
    brush.style := bsClear;
    if (status = clQueen) then
      draw(r.Left+5,r.Top+10,form1.queenImage.Picture.Bitmap);
     if form1.infoBtn.Down then
      begin
       textout(r.Left+2,r.top,inttostr(n));
       textout(r.left+30,r.top,inttostr(game[n].region));
      end;
    end;
  end;
end;

procedure paintAllCells;
var n : byte;
begin
 for n := 1 to gamesize2 do PaintCell(n);
 map2box;
end;

procedure enterNewMode;
begin
 gamestate := gsNew;
 with form1 do
  begin
   newBtn.down := true;
   sizebox.Enabled := true;
   clearBtn.Enabled := true;
   colorbox1.Enabled := true;
   hintimage.Enabled := false;
   orgBtn.Enabled := false;
  end;
end;

procedure enterPlaymode;
var xtest : Ttestresult;
    gameOK : boolean;
begin
 HintCount := 0;
 HintBusy := false;
 gameOK := false;
 xtest := makeregions;
 case xtest.Scode of
  0 : gameOK := true;
  1 : gameMessage('Error: unassigned cell(s)');
  2 : gameMessage('Error: region count unequal to columns/rows');
 end;
 if GameOK then
  begin
   xtest := testregions;
   if xtest.Scode = 0 then
    begin
     gamestate :=gsPlay;
     form1.playBtn.down := true;
     gameMessage(GameOKmessage);
    end
    else begin
          GameMessage('Error: disconnected region(s)');
          gameOK := false;
         end;
  end;
 if gameOK = false then enterNewMode
  else with form1 do
        begin
         clearBtn.Enabled := false;
         sizebox.Enabled := false;
         colorbox1.enabled := false;
         hintImage.Enabled := true;
         orgBtn.Enabled := true;
        end;
end;

procedure Hmarkcell(n,Htype : byte);
//show hint ; Htype 1: X; 2: Queen
var r : Trect;
begin
 with form1.gamebox.Canvas do
  begin
   r := Cell2Rect(n);
   pen.Width := 3;
   pen.Color := $000000;
   brush.Style := bsClear;
   ellipse(r.Left+5,r.Top+5,r.right-5,r.Bottom-5);
  end;
 game[n].Hint := Htype;
end;

procedure ApplyCellMark;
var n : byte;
begin
 for n := 1 to gamesize2 do 
  with game[n] do
   case Hint of
    1 : begin
         status := clClosed;
         hint := 0;
         updateCell(n);
        end;
    2 : begin
         status := clQueen;
         hint := 0;
         UpdateCell(n);
         if form1.Xcheckbox.Checked then AddXX(n);
         exit;     //ony 1 Queen per hint
        end;
   end;
end;

procedure TForm1.newBtnClick(Sender: TObject);
begin
 GameMessage('New Game');
 case TSpeedbutton(sender).Tag of
  1: enterNewMode;
  2: enterPlayMode;
 end;//case
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 clearmap;
 newgame;
 map2box;
 gameMessage('Enter or select new game.');
end;

procedure procGameTest;
//show result of gametest
const wmsg1 = 'multiple queens in ';
      wmsg2 = 'column ';
      wmsg3 = 'row ';
      wmsg4 = 'region ';
      wmsg5 = 'closed ';
      wmsg6 = 'cell not closed by queen ';
      wmsg7 = 'touching queens ';
      wmsg8 = 'No solution.';
      wmsg9 = 'Error: ';
var s : string;
    nstr1,nstr2 : string;
begin
 s := '';
 Gtest := TestGame;
 with Gtest do
  begin
   case Scode of
    2,6 : s := wmsg9+'Game not solved. ';
    5,7 : begin
           s := 'Game Solved.';
           if HintCount = 0 then s := s + 'Congratulations!'
            else s := s + 'Hints:'+inttostr(hintcount);
          end;
   end;//case
   nstr1 := inttostr(n1);
   nstr2 := inttostr(n2);

  if form1.warningbox.Checked then
   begin
    if ((Scode and $1) = 0) and (length(s) = 0) then s := wmsg9;
    case Gtest.Ecode of
     1: s := s + wmsg5+wmsg2+nstr1;             //closed column n
     2: s := s + wmsg5+wmsg3+nstr1;             //       row
     3: s := s + wmsg5+wmsg4+nstr1;             //       region
     5: s := s + wmsg1+wmsg2+nstr1;             //multiple Queens in column n
     6: s := s + wmsg1+wmsg3+nstr1;             //                   row
     7: s := s + wmsg1+wmsg4+nstr1;             //                   region
     8: s := s + wmsg7+nstr1+' '+nstr2;         //touching queens
    end;
   end;
  end;//with Gtest
 gameMessage(s);
end;

function nrstring(w : word) : string;
//bits in w to string
var i : byte;
begin
 result := '';
 for i := 1 to gamesize do
  if ((1 shl i) and w) > 0 then result := result + inttostr(i)+' ';
end;

procedure TForm1.hintImageClick(Sender: TObject);
const tt1 = 'hint-X: ';
      tt2 = 'close cells in ';
      tt3 = 'column ';
      tt4 = 'row ';
      tt5 = 'region ';
      tt6 = 'close diagonal cell(s) of queen';
      tt7 = 'only open cell ';
      tt8 = 'prevent closing ';
      tt9 = 'hint-Q: ';
      tt10= 'covered regions ';
      tt11= 'multiple queens in ';
      tt12= 'Error: ';

var htn,htCol,HtRow,HtReg,Htcrg,s : string;
begin
 if HintActive then ApplyHints;
 procGameTest;
 case Gtest.Scode of
  0,2,4,6 : begin
             if warningbox.checked = false then GameMessage('error detected');
             exit;  //if error
            end;
  3,5,7   : exit;   //full game
 end;
 s := '';
 gameMessage(s);
 procHints;
 with hintresult do
  if test > 0 then
   begin
    htn :=  inttostr(nr);
    htCol := inttostr(column);
    htRow := inttostr(row);
    htReg := inttostr(region);
    htcrg := nrstring(crg);
   end;
 case hintresult.test of
   0 : s := 'no hints';
   1 : s := tt11+tt3+HtCol;
   2 : s := tt11+tt4+HtRow;
   3 : s := tt11+tt5+HtReg;
  11 : s := tt1+tt2+tt3+HtCol;
  12 : s := tt1+tt2+tt4+HtRow;
  13 : s := tt1+tt2+tt5+HtReg;
  21 : s := tt1+tt6;
  31 : s:= tt1+tt8+tt3+HtCol;
  32 : s:= tt1+tt8+tt4+HtRow;
  33 : s:= tt1+tt8+tt5+HtReg;
  41 : s := tt9+tt7+htn+' of column '+HtCol;
  42 : s := tt9+tt7+htn+' of row '+HtRow;
  43 : s := tt9+tt7+htn+' of region '+HtReg;
  51 : s := tt1+tt10+tt3+Htcrg;
  52 : s := tt1+tt10+tt4+Htcrg;
  else s := '';
 end;//case
 if length(s) > 0 then gameMessage(s);
 HintActive := hintresult.test > 0;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges(gamebox,2,$000000);
 paintedges(colorbox1,2,$000000);
 paintedges(hintimage,2,$000000);
 paintedges(sizebox,2,$000000);
 paintColRownrs;
end;

procedure TForm1.colorboxPaint(Sender: TObject);
begin
 clearbox(colorbox1);
 paintcolorbox1;
end;

procedure TForm1.gameboxPaint(Sender: TObject);
begin
 map2box;
end;

procedure TForm1.colorboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var newcolorNr : byte;
begin
 if (x < 2) or (x > 73) or (y < 2) or (y > 121) then exit;
//
 newcolorNr := XY2ColorNr(x,y);
 if newcolorNr = 0 then exit;
//
 if (newColorNr <> selcolorNr) then
  if newColorNr <> tempColorNr then
   begin
    clearColorMarker(tempcolorNr);
    paintColorMarker(newColorNr,$ffffff);
    tempColorNr := newColorNr;
   end;
end;

procedure TForm1.colorboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var newColorNr : byte;
begin
 newColorNr := XY2ColorNr(x,y);
 if newColorNr = 0 then exit;
//
 if selColorNr <> newColorNr then
  begin
   clearColorMarker(selColorNr);
   paintColorMarker(newColorNr,$000000);
   selColorNr := newColorNr;
   tempColorNr := 0;
  end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if tempcolorNr > 0 then begin
                          clearColorMarker(tempcolorNr);
                          tempcolorNr := 0;
                         end;
end;

procedure TForm1.gameboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n : byte;
begin
 if gamestate = gsNew then begin
                            oldcell := 0;
                            exit;
                           end;
 gameMessage('');
 n := XY2CellNr(x,y);
 if button = mbLeft then
  begin
   changeCell(n);
   procGameTest;
  end;
 if button = mbRight then
  if game[n].status <> clOpen then OpenCell(n);
end;

procedure TForm1.gameboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var n : byte;
    w : word;
   UF : boolean;
begin
 if gamestate = gsNew then
  begin
   w := gamesize*48-2;
   if (x < 0) or (y < 0) or (x > w) or (y > w) then exit;
//
   n := XY2CellNr(x,y);
   UF := false;
   if ssleft in shift then
    begin
     game[n].colorNr := selcolorNr;
     UF := true;
    end;
   if ssRight in shift then
    begin
     game[n].colorNr := 0;
     UF := true;
    end;
   if UF and (n <> oldcell) then begin
                                  oldcell := n;
                                  UpdateCell(n);
                                  end;
  end;
end;

procedure TForm1.gameboxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if gamestate = gsNew then paintfences;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 activecontrol := nil;
 gamesize := 2;
 createmap;
 resizegame(8);
 newgame;
 gameMessage(welcome);
 caption := formheader;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map.Free;
end;

procedure TForm1.helpBtnClick(Sender: TObject);
begin
//==
end;

procedure TForm1.warningboxClick(Sender: TObject);
var Gtest : Ttestresult;
begin
 activecontrol := nil;
 if warningbox.checked then Gtest := testGame;
 procGameTest;
end;

procedure TForm1.orgBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n : byte;
begin
HintCount := 0;
 for n := 1 to gamesize2 do
  begin
   eraseCell(n);
   paintCell(n);
  end;
 Map2Box;
 gameMessage('');
 HintBusy := false;
end;

procedure TForm1.infoBtnClick(Sender: TObject);
begin
 if gamestate = gsPlay then paintallcells;
end;

procedure TForm1.loadBtnClick(Sender: TObject);
var lr : byte;
begin
 enterNewMode;
 lr := OpenGame;
 case lr of
  0 : gamemessage('Game opened');
  1 : gamemessage('data error');
  2 : gamemessage('wrong file type');
  4 : gameMessage('I/O error');
  5 : gamemessage('load cancelled');
 end;//case
 if lr = 0 then
  begin
   paintfences;
   paintallcells;
   map2box;
   enterPlayMode;
  end; 
end;

procedure TForm1.saveBtnClick(Sender: TObject);
var sr : byte;
begin
 if gamestate <> gsplay then
  begin
   gameMessage('select PLAY mode to save game');
   exit;
  end; 
 sr := SaveGame;
 case sr of
  0 : gamemessage('game saved');
  1 : gameMessage('write error');
  2 : gameMessage('save cancelled');
 end;//case
end;

procedure TForm1.sizeboxPaint(Sender: TObject);
var i,w,x,y : byte;
    m : string;
begin
 with sizebox.Canvas do
  begin
   pen.Width := 1;
   pen.Color := $808080;
   brush.style := bsSolid;
   brush.color := $ffffff;
   fillrect(rect(0,0,80,80));
   for i := 1 to 3 do
    begin
     moveto(0,i*20);
     lineto(80,i*20);
    end;
   moveto(40,0);
   lineto(40,80);
   font.Name := 'arial';
   font.Height := 16;
   font.style := [fsBold];
   brush.Style := bsClear;
   for i := 0 to 11 do
    begin
     if gamesize = i+5 then begin
                             font.style := [fsbold];
                             font.color := $000000;
                            end
      else begin
            font.style := [];
            font.color := $a0a0a0;
           end;
     m := inttostr(i+5);
     m := m+'*'+m;
     w := textwidth(m);
     x := (i and 1)*40 + ((40-w) shr 1);
     y := (i shr 1)*20 + 2;
     textout(x,y,m);
    end;
  end;
end;

procedure TForm1.sizeboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var newsize : word;
begin
 if (x > 2) and(x < 78) and (y > 2) and (y < 78) then
  begin
   NewSize := (x div 40) + (y div 20)*2 + 5;
   newGame;   //clears game[ ]  array
   resizeGame(newSize);
   map2box;
  end;
 sizebox.Invalidate;
end;

procedure TForm1.colorbox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var newColorNr : byte;
begin
 newColorNr := XY2ColorNr(x,y);
 if newColorNr = 0 then exit;
//
 if selColorNr <> newColorNr then
  begin
   clearColorMarker(selColorNr);
   paintColorMarker(newColorNr,$000000);
   selColorNr := newColorNr;
   tempColorNr := 0;
  end;
end;

procedure TForm1.colorbox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var newcolorNr : byte;
begin
 if (x < 2) or (x > 73) or (y < 2) or (y > 124) then exit;
//
 newcolorNr := XY2ColorNr(x,y);
 if newcolorNr = 0 then exit;
//
 if (newColorNr <> selcolorNr) then
  if newColorNr <> tempColorNr then
   begin
    clearColorMarker(tempcolorNr);
    paintColorMarker(newColorNr,$ffffff);
    tempColorNr := newColorNr;
   end;
end;

procedure TForm1.colorbox1Paint(Sender: TObject);
begin
 clearbox(colorbox1);
 paintcolorbox1;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if gamestate = gsPlay then
  if hintActive then
   case key of
    #32 : begin
           ApplyHints;
           hintActive := false;
           HintImageClick(self);
          end;
    #27 : begin
           CancelHints;
           hintActive := false;
          end;
   end;
end;

procedure TForm1.xcheckboxClick(Sender: TObject);
begin
 activecontrol := nil;
end;

end.
