unit io_unit;

{ load, save of Queens puzzles

  I/O format   (longwords)

  0    ---- ---e ---- ---e ---- ---u ---- ---Q
  1    --version ---- size ---- ---s ---- ---n
  2    ---- Qlev ----color ---region ---status      cell 1
  3    .......................................
  ....                                              cell n*n
       ---f ---f ---0 ---0 ---0 ---0 ---0 ---0
}

interface

uses sysUtils;

function SaveGame : byte;
function OpenGame : byte;

implementation

uses unit1,game_unit;

const buffersize = 148;
      header = 'Queens';
      projectversion = 10; //1.0

var buffer : array[0..147] of longword;
    bix : byte;
    PuzzleVersion : byte;

procedure clearBuffer;
var i : byte;
begin
 for i:= 0 to buffersize-1 do buffer[i]:= 0;
end;

procedure loadbuffer;
var i : byte;
begin
 clearBuffer;
 for i := 0 to 3 do buffer[0] := buffer[0] or (byte(header[i+1]) shl (8*i));
 for i := 0 to 1 do buffer[1] := buffer[1] or (byte(header[i+5]) shl (8*i));
 buffer[1] := buffer[1] or (gamesize shl 16) or projectversion;
 bix := 2;
 for i := 1 to gamesize2 do 
  with game[i] do
   begin
    buffer[bix] := byte(status) or (region shl 8) or (colorNr shl 16) or
                                   (Qlev shl 12);
    inc(bix);
   end;
  buffer[bix] := $ff000000;
  inc(bix);  //correct file length
end;

function saveGame : byte;
var fname,fdir : string;
    f : file;
    xf : integer;
begin
 result := 2;
 clearbuffer;
 loadbuffer;
 with form1.savedialog1 do
  if execute then
   begin
    result := 1;
    fname := ExtractFileName(filename);
    fdir := ExtractFileDir(filename);
    if pos('Q_',fname) <> 1 then insert('Q_',fname,1);
    filename := fdir + '\'+ fname;
{$I+}
    try
     assignfile(f,filename);
     rewrite(f,4);           //4: record size
     blockwrite(f,buffer,bix,xf);
     result := 0;
    finally
     CloseFile(f);
    end;
   end;
end;

function UnpackBuffer : boolean;
var bix,i,tempGameSize : byte;
    w : longword;
begin
 bix := 1;
 w := buffer[bix];
 tempGameSize := (w shr 16) and $0f;
 resizeGame(tempGameSize or $80); //override old setting
 PuzzleVersion := w shr 24;
 inc(bix);
 for i := 1 to tempGameSize*tempGameSize do
  with game[i] do
   begin
    w := buffer[bix];
    status := TCellStatus(w and $f);
    region := (w shr 8)and $0f;
    colorNr := (w shr 16) and $0f;
    Qlev := (w shr 24) and $0f;
    inc(bix);
   end;
 result := buffer[bix] = $ff000000;
end;

function OpenGame : byte;
var fname : string;
    xf : integer;
    f : file;
    s : string;
    i : word;
    w : longword;
begin
 result := 5;
 clearbuffer;
 with form1.OpenDialog1 do
  if execute then
   begin
{$I+}
    try
     result := 4;
     assignfile(f,filename);
     reset(f,4);
     blockread(f,buffer,148,xf);
     result := 3;
    finally
     CloseFile(f);
    end;
   end;
 if result <> 3 then exit;
//
 s := '';
 w := buffer[0];
 for i := 1 to 4 do
  begin
   s := s + chr(w and $ff);
   w := w shr 8;
  end;
 w := buffer[1];
 for i := 1 to 2 do
  begin
   s := s + chr(w and $ff);
   w := w shr 8;
  end;
 if s <> 'Queens' then  begin
                           result := 2;
                           exit;
                          end;
 if unpackBuffer then result := 0
  else begin
        form1.Caption := formheader;
        result := 1;
        exit;
       end;
 fname := form1.opendialog1.filename;
 fname := extractfilename(fname);
 delete(fname,1,2);
 form1.Caption := formheader+':'+fname;
end;

end.
